package cn.com.ctop.toutiao.modules.material.service.impl;

import cn.com.ctop.toutiao.modules.material.entity.BytedanceEffectVideoInfo;
import cn.com.ctop.toutiao.modules.material.mapper.BytedanceEffectVideoInfoMapper;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceVideoInfoService;
import cn.com.ctop.toutiao.modules.material.service.IBytedanceEffectVideoInfoService;
import cn.com.ctop.toutiao.modules.material.vo.BytedanceVideoVo;
import cn.com.ctop.toutiao.modules.report.service.IBytedanceReportMaterialDailyService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
@Slf4j
public class BytedanceEffectVideoInfoServiceImpl extends ServiceImpl<BytedanceEffectVideoInfoMapper, BytedanceEffectVideoInfo> implements IBytedanceEffectVideoInfoService {
    @Autowired
    private IBytedanceReportMaterialDailyService bytedanceReportMaterialDailyService;
    @Autowired
    private IByteDanceVideoInfoService videoInfoService;
    @Override
    public void loadEffectVideo(String date) {
        //1:查询素材报表
        List<BytedanceVideoVo> vos = bytedanceReportMaterialDailyService.getVideoVoByDate(date);
        if(null == vos||vos.isEmpty()){
            log.info("素材数据报表为空");
            return;
        }
        for (BytedanceVideoVo vo:vos) {
            BytedanceEffectVideoInfo effectVideoInfo = new BytedanceEffectVideoInfo();
            effectVideoInfo.setCode(vo.getCode());
            effectVideoInfo.setUrl(vo.getUrl());
            effectVideoInfo.setInitialCostDate(vo.getInitialCostDate());
            effectVideoInfo.setCreateTime(new Date());
            effectVideoInfo.setUpdateTime(new Date());
            this.save(effectVideoInfo);
        }
    }

    @Override
    public BytedanceEffectVideoInfo getVideoByCode(String code) {
        QueryWrapper<BytedanceEffectVideoInfo>queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("code",code);
        queryWrapper.last("limit 1");
        return this.getOne(queryWrapper);
    }
}
